﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace ColumnChooserPositionTest
{
    public partial class Form1 : Form
    {
        DataSet dataSet;
        DataTable dataTable;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateDataSet();
            ultraGrid1.DataSource = dataSet;

            //ultraGrid1.DisplayLayout.Override.HeaderAppearance.ForeColor = Color.Red;
            ultraGrid1.DisplayLayout.Bands[0].Columns[0].Header.Caption = "1st Column";
        }

        private void CreateDataSet()
        {
            dataSet = new DataSet();
            dataTable = new DataTable("Customers");

            dataTable.Columns.Add("CustomerID", typeof(string));
            DataColumn[] Keys = new DataColumn[1];
            Keys[0] = dataTable.Columns[0];
            dataTable.PrimaryKey = Keys;
            dataTable.Columns.Add("CompanyName", typeof(string));
            dataTable.Columns.Add("ContactName", typeof(string));
            dataTable.Columns.Add("Address", typeof(string));
            dataTable.Columns.Add("City", typeof(string));
            dataTable.Columns.Add("Country", typeof(string));

            DataRow row = dataTable.NewRow();
            row["CustomerID"] = "ALFKI";
            row["CompanyName"] = "Alfred Futterkiste";
            row["ContactName"] = "Ana Anders";
            row["Address"] = "Obere Str. 57";
            row["City"] = "Berlin";
            row["Country"] = "Germany";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "ANATR";
            row["CompanyName"] = "Ana Trujillo Emparedados y helados";
            row["ContactName"] = "Ana Trujillo";
            row["Address"] = "Avda. de la Constitución 2222";
            row["City"] = "México D.F.";
            row["Country"] = "Mexico";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "ANTON";
            row["CompanyName"] = "Antonio Moreno Taquería";
            row["ContactName"] = "Antonio Moreno";
            row["Address"] = "Mataderos  2312";
            row["City"] = "México D.F.";
            row["Country"] = "Mexico";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "AROUT";
            row["CompanyName"] = "Around the Horn";
            row["ContactName"] = "Thomas Hardy";
            row["Address"] = "120 Hanover Sq.";
            row["City"] = "London";
            row["Country"] = "UK";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BERGS";
            row["CompanyName"] = "Berglun snabbköp";
            row["ContactName"] = "Christina Berglund";
            row["Address"] = "Berguvsvägen  8";
            row["City"] = "Luleå";
            row["Country"] = "Sweden";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BLAUS";
            row["CompanyName"] = "Blauer See Delikatessen";
            row["ContactName"] = "Hanna Moos";
            row["Address"] = "Forsterstr. 57";
            row["City"] = "Mannheim";
            row["Country"] = "Germany";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BLONP";
            row["CompanyName"] = "Blondel père et fils";
            row["ContactName"] = "Frédérique Citeaux";
            row["Address"] = "24, place Kléber";
            row["City"] = "Strasbourg";
            row["Country"] = "France";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BOLID";
            row["CompanyName"] = "Bólido Comidas preparadas";
            row["ContactName"] = "Martín Sommer";
            row["Address"] = "C/ Araquil, 67";
            row["City"] = "Madrid";
            row["Country"] = "Spain";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BONAP";
            row["CompanyName"] = "Bon app'";
            row["ContactName"] = "Laurence Lebihan";
            row["Address"] = "12, rue des Bouchers";
            row["City"] = "Marseille";
            row["Country"] = "France";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BOTTM";
            row["CompanyName"] = "Bottom-Dollar Markets";
            row["ContactName"] = "Elizabeth Lincoln";
            row["Address"] = "23 Tsawassen Blvd.";
            row["City"] = "Tsawassen";
            row["Country"] = "Canada";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "BSBEV";
            row["CompanyName"] = "B's Beverages";
            row["ContactName"] = "Elizabeth Ashworth";
            row["Address"] = "Fauntleroy Circus";
            row["City"] = "London";
            row["Country"] = "UK";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "CACTU";
            row["CompanyName"] = "Cactus Comidas para llevar";
            row["ContactName"] = "Patricio Simpson";
            row["Address"] = "Cerrito 333";
            row["City"] = "Buenos Aires";
            row["Country"] = "Argentina";
            dataTable.Rows.Add(row);

            row = dataTable.NewRow();
            row["CustomerID"] = "CENTC";
            row["CompanyName"] = "Centro Comercial de Moctezuma";
            row["ContactName"] = "Francisco Chang";
            row["Address"] = "Sierras de Granada 9993";
            row["City"] = "México D.F.";
            row["Country"] = "Mexico";
            dataTable.Rows.Add(row);

            dataSet.Tables.Add(dataTable);
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSelectorHeaderStyle = RowSelectorHeaderStyle.ColumnChooserButton;
            //e.Layout.Bands[0].Columns[0].Header.Caption = "1st Column";

            //e.Layout.Override.HeaderAppearance.TextHAlign = HAlign.Right;
           
        }

        private void ultraGrid1_BeforeColumnChooserDisplayed(object sender, BeforeColumnChooserDisplayedEventArgs e)
        {
            ColumnChooserGrid ccGrid = (ColumnChooserGrid)e.Dialog.ColumnChooserControl.Controls[0];
            if (!(ccGrid.DrawFilter is ColumnChooserAlignmentDrawFilter))
            {
                // If we haven't Set Our DrawFilter;
                ColumnChooserAlignmentDrawFilter drawFilter = new ColumnChooserAlignmentDrawFilter();
                // We still want to use the default draw filter, the ColumnChooserDrawFilter will call this
                drawFilter.OriginalDrawFilter = ccGrid.DrawFilter;
                ccGrid.DrawFilter = drawFilter;
            }
            e.Dialog.StartPosition = FormStartPosition.Manual;
            e.Dialog.DesktopLocation = Control.MousePosition;
        }

        
    }

    public class ColumnChooserAlignmentDrawFilter : IUIElementDrawFilter
    {
        public IUIElementDrawFilter OriginalDrawFilter { get; set; }

        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            bool retVal = this.OriginalDrawFilter.DrawElement(drawPhase, ref drawParams);

            if (drawPhase == DrawPhase.BeforeDrawElement && drawParams.Element is HeaderUIElement)
            {
                // Set the alignment (this could be exposed as a property)
                drawParams.AppearanceData.TextHAlign = HAlign.Right;
            }

            return retVal;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            DrawPhase retVal = this.OriginalDrawFilter.GetPhasesToFilter(ref drawParams);

            if (retVal == DrawPhase.None && drawParams.Element is HeaderUIElement)
            {
                retVal = DrawPhase.BeforeDrawElement;
            }
            return retVal;
        }

        #endregion
    }
}
